#ifndef cDECKHEADER
#define cDECKHEADER

#include <vector>
#include <cassert>
#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

typedef int cCard;

//define a list of possible strategy
enum cStrat {sHITSOFT17, sHIT16};

class cDeck
{
public:
	cDeck(int deck = 1, bool ten = true);  //if ten = true, then J, Q and K will be counted as 10

	//return 1 = A, 2 = 2, 3 = 3 .... 11 = J, 12 = Q, 13 = K
	int Deal(); //O(1)
	int NumLeft(){return Total;};
	int NumLeft(int n);

	void Reset(void);
	void Output(void);

	double HighLowCount(void);



	//this is only an estimation
	vector<double> Prob(const int nTotal, const bool bSoft = false, cStrat s = sHITSOFT17);

	//force a card to be dealt, very slow O(# of card in deck)
	//the setting bTen doesn't affect the funciton at all
	int ForceDeal(cCard card);


private:
	//
	int nDeck;
	bool bTen;

	//record down the number of each card left
	vector<cCard> Card;
 
	//total number of card
	int Total;
	int HighLowIndex;

	//the deck
	vector<cCard> Deck;
};

#endif